import type { ButtonProps, HideErrorPropType, IdPropType, InputEmailAPI, InputEmailStates, InputTypeOnDefault, InputTypeOnOff, KoliBriHorizontalIcons, LabelWithExpertSlotPropType, MsgPropType, MultiplePropType, NamePropType, Stringified, SuggestionsPropType, SyncValueBySelectorPropType, TooltipAlignPropType } from '../../schema';
import type { JSX } from '../../stencil-public-runtime';
export declare class KolInputEmail implements InputEmailAPI {
    private readonly host?;
    private ref?;
    private readonly catchRef;
    getValue(): Promise<string | undefined>;
    private readonly onKeyDown;
    private readonly onInput;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: string;
    _alert?: boolean;
    _autoComplete?: InputTypeOnOff;
    _disabled?: boolean;
    _error?: string;
    _hasCounter?: boolean;
    _hideError?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: Stringified<KoliBriHorizontalIcons>;
    _id?: IdPropType;
    _label: LabelWithExpertSlotPropType;
    _maxLength?: number;
    _msg?: MsgPropType;
    _multiple?: boolean;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _pattern?: string;
    _placeholder?: string;
    _readOnly?: boolean;
    _required?: boolean;
    _smartButton?: Stringified<ButtonProps>;
    _suggestions?: SuggestionsPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value?: string;
    state: InputEmailStates;
    constructor();
    validateAccessKey(value?: string): void;
    validateAlert(value?: boolean): void;
    validateAutoComplete(value?: InputTypeOnOff): void;
    validateDisabled(value?: boolean): void;
    validateError(value?: string): void;
    validateHasCounter(value?: boolean): void;
    validateHideError(value?: HideErrorPropType): void;
    validateHideLabel(value?: boolean): void;
    validateHint(value?: string): void;
    validateIcons(value?: Stringified<KoliBriHorizontalIcons>): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMaxLength(value?: number): void;
    validateMsg(value?: MsgPropType): void;
    validateMultiple(value?: MultiplePropType): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validatePattern(value?: string): void;
    validatePlaceholder(value?: string): void;
    validateReadOnly(value?: boolean): void;
    validateRequired(value?: boolean): void;
    validateSuggestions(value?: SuggestionsPropType): void;
    validateSmartButton(value?: ButtonProps | string): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTouched(value?: boolean): void;
    validateValue(value?: string): void;
    componentWillLoad(): void;
}
