import type { Events } from '../enums';
import type { EventValueOrEventCallback } from '../types/callbacks';
import type { Generic } from 'adopted-style-sheets';
import type { KoliBriSortDirection } from '../types';
export type SortEventPayload = {
    key: string;
    currentSortDirection: KoliBriSortDirection;
};
export type SelectionChangeEventPayload = string[];
export type TableCallbacksPropType = {
    [Events.onSort]?: EventValueOrEventCallback<MouseEvent, SortEventPayload>;
    [Events.onSelectionChange]?: EventValueOrEventCallback<Event, SelectionChangeEventPayload>;
};
export type PropTableCallbacks = {
    on: TableCallbacksPropType;
};
export declare const validateTableCallbacks: (component: Generic.Element.Component, value?: TableCallbacksPropType) => void;
